/**
 * @(#)AIObject.java
 * 
 *  Copyright Anthony Yakovlev <yakovlev@rain.ifmo.ru> and Michail Lukin <michail@users.msn.com>
 */

package ru.ifmo.knim.controlled;

import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;
import ru.ifmo.knim.main.GamePlay;
import ru.ifmo.knim.main.MoveResult;

/**
 * An object that controls AI logics pipeline 
 * @author Anthony Yakovlev
 */
public class AIObject implements ControlledObject {
	
	/**
	*@unimod.action.descr    
	*/
	public void z1(StateMachineContext context) {
		GamePlay.getGamePlay().aiStartup();
		return;
	}

	/**
	*@unimod.action.descr   
	*/
	public int x1(StateMachineContext context) {
		Object object = context.getEventContext().getParameter("XORSumm");
		return ((Integer) object).intValue();
	}

	/**
	*@unimod.action.descr     ""
	*/
	public void z2(StateMachineContext context) {
		GamePlay.getGamePlay().sendSafeMove();
	}

	/**
	*@unimod.action.descr     ""
	*/
	public void z3(StateMachineContext context) {
		GamePlay.getGamePlay().sendUnsafeMove();
	}

	/**
	*@unimod.action.descr  
	*/
	public void z4(StateMachineContext context) {
		// fake by AY
		MoveResult move = new MoveResult();
		move.isGameOver = true;
		
		GamePlay.getGamePlay().resendMove(move);
	}
}
