/**
 * @(#)GameObject.java
 * 
 *  Copyright Anthony Yakovlev <yakovlev@rain.ifmo.ru> and Michail Lukin <michail@users.msn.com>
 */

package ru.ifmo.knim.controlled;

import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;

import ru.ifmo.knim.main.GamePlay;
import ru.ifmo.knim.main.MoveResult;
import ru.ifmo.knim.screens.*;

/**
 * This is the class that controls the game process
 * @author Anthony Yakovlev
 */
public class GameObject implements ControlledObject {
	
	/**
	 * Determines, whether the player has wone or not
	 */
	boolean hasPlayerWon = false;

	/**
	*@unimod.action.descr  
	*/
	public void z1(StateMachineContext context) {
		GameScreen.getScreen().restartIface();
	}

	/**
	*@unimod.action.descr  
	*/
	public boolean x1(StateMachineContext context) {
		
		// get param
		Object input = context.getEventContext().getParameter("Move");
		
		// test input
		int [] move = (int []) input;
		MoveResult result = MoveResult.getMoveResult(move);
		if (result == null) {
			return false;
		} else {
			return result.nTaken <= GamePlay.getGamePlay().getGameInfo().getFishInLine(result.takenFrom);
		}
	}

	/**
	*@unimod.action.descr  
	*/
	public void z2(StateMachineContext context) {
		// understands different kinds of input
		// get param
		Object input = context.getEventContext().getParameter("Move");
		if (input != null) {
			GameScreen.getScreen().takeStones(
					MoveResult.getMoveResult( (int []) input )
			);
		} else {
			input = context.getEventContext().getParameter("AIMove");
			MoveResult move = (MoveResult) input;
			GameScreen.getScreen().takeStones(move);
			GameScreen.getScreen().updateStatus(move);
			move.isGameOver = false;
			GamePlay.getGamePlay().resendMove(move);
		}
		
	}

	/**
	*@unimod.action.descr  
	*/
	public boolean x2(StateMachineContext context) {
		return GamePlay.getGamePlay().getGameInfo().isGameover();
	}

	/**
	*@unimod.action.descr   
	*/
	public void z3(StateMachineContext context) {
		hasPlayerWon = GamePlay.getGamePlay().getGameInfo().isGameover();
	}

	/**
	*@unimod.action.descr   
	*/
	public boolean x3(StateMachineContext context) {
		return hasPlayerWon;
	}
}
