/**
 * @(#)GameEventProvider.java
 * 
 *  Copyright Anthony Yakovlev <yakovlev@rain.ifmo.ru> and Michail Lukin <michail@users.msn.com>
 */

package ru.ifmo.knim.providers;

import com.evelopers.unimod.runtime.EventProvider;
import com.evelopers.unimod.runtime.ModelEngine;

import javax.swing.*;

import ru.ifmo.knim.screens.*;

/**
 * Events that are send by interface engine
 * @author Anthony Yakovlev   
 */
public class InterfaceEventProvider implements EventProvider {
	
	/**
	* @unimod.event.descr    
	*/
	public static final String E4 = "e4";
	/**
	* @unimod.event.descr    " "
	*/
	public static final String E5 = "e5";
	/**
	* @unimod.event.descr    " "
	*/
	public static final String E2 = "e2";
	/**
	* @unimod.event.descr   
	*/
	public static final String E6 = "e6";
	/**
	* @unimod.event.descr    
	*/
	public static final String E3 = "e3";
	/**
	* @unimod.event.descr    
	*/
	public static final String E7 = "e7";
	
    /* (non-Javadoc)
     * @see com.evelopers.unimod.runtime.EventProvider#init(com.evelopers.unimod.runtime.EventHandler, com.evelopers.unimod.core.stateworks.StateMachine)
     */
    public void init(ModelEngine engine) {
    	GameScreen.getScreen().init(engine);

        try {
        	// invoke in Swing event thread
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                	GameScreen.getScreen().setVisible(true);
                }
            });
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
    /* (non-Javadoc)
     * @see com.evelopers.unimod.runtime.EventProvider#dispose()
     */
    public void dispose() {
        try {
        	// invoke in Swing event thread
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                	GameScreen.getScreen().setVisible(false);
                	GameScreen.getScreen().dispose();
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
